<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'DevExAccordion',
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      selectedIndex: 0,
    };
  },
  methods: {
    selectItem(index) {
      this.selectedIndex = this.selectedIndex === index ? 0 : index;
    },
  },
});
</script>

<template>
  <div id="accordion-section">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="7">
          <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-32">{{
            data.title
          }}</SlpTypography>
          <SlpTypography variant="heading5" tag="h5">{{
            data.subtitle
          }}</SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow class="accordion__container">
        <SlpColumn :cols="6">
          <div class="accordion__section">
            <div
              v-for="(item, index) in data?.singleAccordionGroupItems"
              :key="index"
              class="accordion__header"
              :class="selectedIndex === index ? 'active' : ''"
              @click="selectItem(index)"
            >
              <div
                :class="
                  selectedIndex === index ? 'gradient-header' : 'border-header'
                "
                class="accordion__border"
              ></div>
              <SlpTypography
                tag="h5"
                variant="heading5-bold"
                class="slp-mt-32 accordion-header-text"
                >{{ item.fields.internalName }}
                <span class="open-icon">{{
                  selectedIndex === index ? '-' : '+'
                }}</span></SlpTypography
              >
              <SlpTypography
                v-if="selectedIndex === index"
                tag="p"
                variant="body1"
                class="slp-mb-32 slp-mt-16 slp-pr-32 accordion-header-subtitle"
              >
                {{
                  data.singleAccordionGroupItems[selectedIndex].fields
                    ?.description
                }}
              </SlpTypography>
            </div>
          </div>
        </SlpColumn>
        <SlpColumn :cols="6">
          <div class="accordion__content">
            <Transition name="block-fade">
              <div v-if="selectedIndex !== null">
                <SlpIcon
                  name="quote"
                  alt="quote Icon"
                  variant="marketing"
                  size="md"
                />
                <div
                  tag="p"
                  variant="body1"
                  class="quote-body slp-mt-16 slp-mb-32"
                  :class="selectedIndex ? 'active' : ''"
                  v-html="
                    $md.render(
                      data.singleAccordionGroupItems[selectedIndex].fields
                        ?.quote?.fields?.quoteText,
                    )
                  "
                ></div>
                <SlpTypography tag="p" variant="body2-bold" class="slp-mb-4">
                  {{
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.author
                  }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body2">
                  {{
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.authorTitle
                  }}
                </SlpTypography>
                <img
                  :src="
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.authorHeadshot?.fields?.image?.fields?.file?.url
                  "
                  :alt="
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.authorHeadshot?.fields?.image?.fields?.file
                      ?.fileName
                  "
                  class="accordion__content-headshot"
                />
                <SlpButton
                  variant="tertiary"
                  :href="
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.cta?.fields?.externalUrl
                  "
                  :data-ga-name="
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.cta?.fields?.dataGaName
                  "
                  :data-ga-location="
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.cta?.fields?.dataGaLocation
                  "
                >
                  {{
                    data.singleAccordionGroupItems[selectedIndex].fields?.quote
                      ?.fields?.cta?.fields?.text
                  }}
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
              </div>
            </Transition>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#accordion-section {
  padding: 120px 0;
  background: linear-gradient(180deg, $color-surface-50, hsla(0, 0%, 100%, 0)),
    linear-gradient(
      126deg,
      #eee7fd,
      rgba(246, 243, 254, 0.83) 49.71%,
      rgba(255, 212, 216, 0.45)
    );
}

.accordion {
  &__container {
    margin-top: $spacing-96;
    display: flex;
    background: $color-surface-50;
    border-radius: 8px 8px 200px 8px;
    padding: $spacing-32;
  }

  &__header:not(:first-child) {
    margin-top: $spacing-32;
  }

  &__header:last-child {
    margin-bottom: $spacing-32;
  }

  &__section {
    flex: 1;
    margin-right: $spacing-24;
    @media (max-width: $breakpoint-md) {
      margin-right: 0;
    }

    .accordion__header.active {
      .gradient-header,
      .accordion-header-text,
      .accordion-header-subtitle {
        animation: fade-in 0.5s ease-in forwards;
      }
    }

    .active {
      position: relative;

      &::after {
        content: '';
        position: absolute;
        transition: none;
        animation: none;
        top: 50%;
        right: -24px;
        border-style: solid;
        border-width: 12px 12px 12px 0;
        border-color: transparent rgba(249, 160, 38, 0.1) transparent
          transparent;

        @media (max-width: $breakpoint-md) {
          display: none;
        }
      }

      .accordion-header-text {
        color: $color-text-300;
      }
    }

    .gradient-header {
      background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
      height: 3px;
      width: 100%;
    }

    .border-header {
      background-color: $color-surface-300;
      height: 3px;
      width: 100%;
    }

    .open-icon {
      float: right;
      font-weight: 300;
      font-size: 30px;
    }

    .accordion-header-text {
      cursor: pointer;
      color: $color-text-200;
    }
  }

  &__content {
    background: linear-gradient(
      100.97deg,
      rgba(249, 160, 38, 0.1) -2.77%,
      rgba(166, 134, 242, 0.1) 82.08%,
      rgba(89, 42, 200, 0.1) 169.71%
    );
    flex: 2;
    border-radius: 8px 8px 170px 8px;
    padding: $spacing-32;
    min-height: 100%;
    position: relative;

    .quote-body {
      font-size: 18px;
      line-height: 28px;
    }
  }

  &__content-headshot {
    max-width: 160px;
    max-height: 80px;
    margin: $spacing-32 0;
    display: block;
  }
}

@keyframes fade-in {
  from {
    opacity: 0;
    transform: translateY(10px);
  }
  to {
    opacity: 1;
    transform: translateY(0);
  }
}
</style>
